#!/usr/bin/env python2.5
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
# MA  02110-1301, USA.
#

import glob
import os
from distutils.core import setup

version = '1.0'

# files to install
inst_desktop = ['maemo-wordpy.desktop']
inst_py = ['maemowordpy.py', 'maemowordpy.glade']
pixmaps = ['pixmaps/link.png', 'pixmaps/paragraph.png', 'pixmaps/bold.png', \
'pixmaps/italic.png', 'pixmaps/image.png', 'pixmaps/underline.png', \
'pixmaps/strikethrough.png', 'pixmaps/add.png', 'pixmaps/left.png', \
'pixmaps/right.png', 'pixmaps/center.png', 'pixmaps/fill.png', 'pixmaps/code.png',\
'pixmaps/quote.png', 'pixmaps/li.png', 'pixmaps/ul.png', 'pixmaps/ol.png', \
'pixmaps/fontcolor.png', 'pixmaps/bgcolor.png', 'pixmaps/fontsize.png', \
'pixmaps/sup.png', 'pixmaps/sub.png', 'pixmaps/mono.png', 'pixmaps/cite.png', \
'pixmaps/abbr.png', 'pixmaps/acron.png', 'pixmaps/remove.png', 'pixmaps/new.png', \
'pixmaps/open.png', 'pixmaps/save.png', 'pixmaps/edit.png', 'pixmaps/add-big.png', \
'pixmaps/up.png', 'pixmaps/cancel.png', 'pixmaps/post_edited.png', \
'pixmaps/img-missing.png', 'pixmaps/logo.png', 'pixmaps/maemo-wordpy.png']
inst_modules = ['wordpy/__init__.py', 'wordpy/blogger.py','wordpy/flickr.py', \
'wordpy/htmltags.py', 'wordpy/imaged.py', 'wordpy/io.py', 'wordpy/picasa.py', \
'wordpy/posting.py', 'wordpy/settings.py', 'wordpy/utils.py', \
'wordpy/wordpress.py', 'wordpy/livejournal.py']
inst_dbus = ['maemowordpy.service']
inst_icon = ['maemo-wordpy.png' ]
inst_icon_sca = ['pixmaps/maemo-wordpy.png']
backup_conf  = ['maemowordpy-backup.conf']

data_files = [
  ('share/applications/hildon', inst_desktop),
  ('share/maemo-wordpy',   inst_py),
  ('share/maemo-wordpy/pixmaps',   pixmaps), 
  ('share/maemo-wordpy/wordpy',   inst_modules),
  ('share/dbus-1/services',   inst_dbus), 
  ('share/icons/hicolor/26x26/hildon/',   inst_icon),
  ('share/icons/hicolor/scalable/hildon/',   inst_icon_sca), 
  ('/etc/osso-backup/applications/',   backup_conf), 
]

setup(
  name         = 'maemo-wordpy',
  version      = version,
  description  = 'Blogging client for Internet Tablets',
  author       = 'Daniel Martin Yerga',
  author_email = 'dyerga@gmail.com',
  url          = 'https://garage.maemo.org/projects/maemo-wordpy',
  data_files   = data_files
)
