# Copyright (C) 2008 by Daniel Martin Yerga
# <dyerga@gmail.com>
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


from wordpy import wordpress, blogger
import os

def to_wordpress(url, user, password, title_entry, postpassword_entry, tags_entry, \
                pings_cb, comments_cb, postBuffer, extendedBuffer, publishopt_combo, \
                slug_entry, cats_model, tracks_entry, ttags_entry, edited, postid, \
                rtags, posting_info, sch_time, sch_date, schedule_cbtn):
        
    #print url, user, password
    wpclient = wordpress.create_wordpress_client(url, user, password)
    if wpclient is None:
        print 'problems creating wpclient'
        return None
    post = wordpress.WordPressPost()
    #Title
    post.title = title_entry.get_text()
    post.password = postpassword_entry.get_text() 
    
    post.tags = tags_entry.get_text()
    if post.tags == '':
        post.tags = rtags    
    else:
        if rtags == '':
            post.tags = post.tags
        else:
            post.tags = post.tags + ', ' + rtags
            
    # Allow Pings        
    if pings_cb.get_active():
        post.allowPings = 'open'
    else:
        post.allowPings = 'closed'

    # Allow Comments
    if comments_cb.get_active():
        post.allowComments = 'open'
    else:
        post.allowComments = 'closed'  

    if schedule_cbtn.get_active():
        import time           
        #sch_time = 17:08
        #sch_date = 20/8/2008
        #date = (year, month, day, hour, minutes, seconds, weekday, yearday, dst)
        # dst = -1 --> localtime
        if time.localtime()[8] == 0:
            onehour = - 1
        else:
            onehour = 0
        
        sch_date = sch_date.split('/')
        sch_time = sch_time.split(':')

        post.date = (int(sch_date[2]), int(sch_date[1]), int(sch_date[0]), \
                    int(sch_time[0])+onehour, int(sch_time[1]), 00, 0, 0, -1)
        
    #Text
    start, end = postBuffer.get_bounds()
    main_posttext = postBuffer.get_text(start, end) 

    start, end = extendedBuffer.get_bounds()
    extended_text = '<br /><br />' + extendedBuffer.get_text(start, end)
    
    #TODO: if choose the wordpress/picasa/flicrk button to upload, put here an if/else
    posting_info.set_label("Uploading images")
    main_posttext = _local_img_to_server(wpclient, main_posttext, 'Wordpress')    
    extended_text = _local_img_to_server(wpclient, extended_text, 'Wordpress')
    posting_info.set_label("Uploading content")
    
    main_posttext = set_technorati_tags(ttags_entry, main_posttext)    
    post.trackbacks = get_trackbacks(tracks_entry)
    post.categories = get_chosen_cats(cats_model)
 
    #Excerpt
    #start, end = self.txtBufferExc.get_bounds()
    #post.excerpt = self.txtBufferExc.get_text(start, end) 
            
    #post status = draft, private, publish, pending
    post.status = publishopt_combo.get_active_text()
    post.name = slug_entry.get_text() 
    post.description = main_posttext
    if extended_text != "<br /><br />":
        post.textMore = extended_text

    if edited:
        newpostid = wpclient.editPost(postid, post)
    else:
        newpostid = wpclient.newPost(post)

    return newpostid
    
def get_chosen_cats(cats_model):
    cats_id = []
    for i in range(len(cats_model)):
        if cats_model[i][0] == True:
            cats_id.append(cats_model[i][1])
    return cats_id

def get_trackbacks(tracks_entry):
    trackbacklist = []
    trackbackURLS = tracks_entry.get_text()
    for i in trackbackURLS.split(" "):
        for j in i.split(","):
            for k in j.split(";"):
                if (k != " " and k != ""):
                    trackbacklist.append(k)
        
    return trackbacklist    

def set_technorati_tags(ttags_entry, posttext):
    ttags = ttags_entry.get_text()
    ttagslist = []
    for i in ttags.split(", "):
        for j in i.split(" ,"):
            for k in j.split(","):
                for l in k.split("; "):
                    for m in l.split(" ;"):
                        for n in m.split(";"):
                            if (n != " " and n != ""):
                                ttagslist.append(n)

    html_ttagslist = []
    for ttag in ttagslist:
        html = '<a href="http://technorati.com/tag/' + ttag + '" rel="tag">' + ttag + '</a>'
        html_ttagslist.append(html)
    
    final_ttags_text = (', ').join(html_ttagslist)

    #If there aren't tags 
    if final_ttags_text == '':
        posttext = posttext
    #If there are tags add the links to main post
    else: 
        posttext += '<br /><br />' + \
        '<p style="text-align: right"><small>Technorati Tags: ' + \
        final_ttags_text + '</small><br /></p>'

    return posttext

def _local_img_to_server(client, texto_post, blogsystem):
    ###upload local images, and change its filename for its url###
    if texto_post.find("file://") >= 0:
        import re
        for i in range(texto_post.count('file://')):
            hele = re.compile(r'"file://[^$%]+"')
            a = hele.findall(texto_post)
            print a
            if a[0].count('"') == 2:
                b = a[0]
                c = b.replace('"', '')
            else:
                b = a[0].split('"')
                for j in range(len(b)):
                    if b[j].find("file://") >= 0:					
                        c = b[j].replace('"', '')

            d = c.replace('file://', '')
            if not os.path.exists(d):
                print "Error uploading image:\nFile doesn't exist."

            if blogsystem == 'Wordpress':           
                imageSrc = client.newMediaObject(d)
            elif blogsystem == 'Blogger':
                import gdata.photos.service
                service = gdata.photos.service.PhotosService()
                service.ClientLogin(client.email, client.password)

                ## Some code for MaemoPublishr :) ##
                img = None
                # Get album feed
                albums = service.GetUserFeed().entry        
                # See if the album exists
                for a in albums:
                    if a.title.text == 'Maemo WordPy':
                        img = service.InsertPhotoSimple(a, 'wordpy-image', '', d)
                # The selected album was not found, create new one
                if not img:
                    new_album = service.InsertAlbum(title='Maemo WordPy', \
                        summary='Images inserted with Maemo WordPy blogging client.')
                    img = service.InsertPhotoSimple(new_album, 'wordpy-image', '', d)

                photo_urls = []
                for i in img.link:
                    photo_urls.append(i.href)
                imageSrc = photo_urls[4]
                #print 'source:', imageSrc
                del photo_urls

            ####if d is a edited temp image, delete it###
            if d.find('maemowordpy') >= 0:
                os.remove(d)
            texto_post = texto_post.replace(c, imageSrc)
    return texto_post

def to_blogger(url, user, password, title_entry, postBuffer, ttags_entry, \
                tags_entry, publishopt_combo, blogid, edited, postid, rtags, \
                posting_info, sch_time, sch_date, schedule_cbtn):
    import gdata, atom
    try:
        bgclient = blogger.create_blogger_client(user, password)
    except:
        print 'problems creating bgclient'
        return
        
    post = gdata.GDataEntry()
    title = title_entry.get_text()
    post.title = atom.Title(title_type='xhtml', text=title)
    #Text
    start, end = postBuffer.get_bounds() 
    main_posttext = postBuffer.get_text(start, end)
    posting_info.set_label("Uploading images")
    main_posttext = _local_img_to_server(bgclient, main_posttext, 'Blogger')
    posting_info.set_label("Uploading content")    
    main_posttext = set_technorati_tags(ttags_entry, main_posttext)
    post.content = atom.Content(content_type='html', text=main_posttext)

    ## Set labels to blogger post
    labels = tags_entry.get_text()
    if labels == '':
        labels = rtags    
    else:
        if rtags == '':
            labels = labels
        else:
            labels = labels + ', ' + rtags
            
    if labels != '':
        post.category = atom.Category()
        post.category.term = labels
        post.category.scheme = "http://www.blogger.com/atom/ns#"
    else:
        print 'no labels.'
    # Get publish/draft post
    if publishopt_combo.get_active_text() == 'draft':
        control = atom.Control()
        control.draft = atom.Draft(text='yes')
        post.control = control

    if schedule_cbtn.get_active():  
        import time
        sch_date = sch_date.split('/')
        sch_time = sch_time.split(':')

        post_date = (int(sch_date[2]), int(sch_date[1]), int(sch_date[0]), \
                    int(sch_time[0]), int(sch_time[1]), 00, 0, 0, -1)
        post_date = time.strftime("%Y-%m-%dT%H:%M:00.000", post_date)
        
        if time.daylight != 0:
            diference = time.altzone/60/60        
        else:
            diference = (time.altzone/60/60) - 1
        
        print diference
        
        if diference < 0:
            dst_sign = '+'  
        else:
            dst_sign = '-' 

        if time.localtime()[8] == 0:
            diference = abs(diference) - 1

        if abs(diference) < 10:
            post_date += '%s0%s:00' % (dst_sign, abs(diference))
        else:
            post_date += '%s%s:00' % (dst_sign, abs(diference))

        #print 'Post date:', post_date
        #print 'localtime: ', time.localtime()
        #print 'gtmtime: ', time.gmtime()

        #Date
        #post_date = '2008-08-11T18:00:00.000+02:00'
        post.published = atom.Published(text=post_date)
    
    if edited:
        new_post = bgclient.Put(post, postid)
    else:
        new_post = bgclient.Post(post, '/feeds/'+str(blogid)+'/posts/default')    

    return new_post

def to_livejournal(user, password, postBuffer, title_entry, tags_entry, date, \
                    edited, postid, rtags, comments_cb, sch_time, sch_date):
    from wordpy import livejournal
    ljclient = livejournal.create_livejournal_client(user, password)

    start, end = postBuffer.get_bounds() 
    text = postBuffer.get_text(start, end)
    print 'content: ', text
    
    text = text.replace('\n', '<br />')
    
    subject =  title_entry.get_text()
    
    if comments_cb.get_active():
        nocomments = 0
    else:     
        nocomments = 1
    
    tags = tags_entry.get_text()
    if tags == '':
        tags = rtags    
    else:
        if rtags == '':
            tags = tags
        else:
            tags = tags + ', ' + rtags
            
    print 'tags: ', tags

    
    #sch_date = sch_date.split('/')
    #sch_date = '%s-%s-%s' % (sch_date[2], sch_date[1], sch_date[0])
    
    #post_date = '%s %s:00' % (sch_date, sch_time)
    #print post_date

    #eventtime = '2008-08-12 15:05:06'
    
    if edited:
        result = ljclient.edit(postid, date, {'subj': subject, 'text': text, \
                                'tags': tags, 'nocomments' : nocomments})    
    else:
        result = ljclient.post({'subj': subject, 'text': text, 'tags': tags, \
                                'nocomments' : nocomments})
    return result


def edit_post_status_wordpress(url, user, password, postid, status):
    wpclient = wordpress.create_wordpress_client(url, user, password)
    if wpclient is None:
        print 'problems creating wpclient'
        return

    post = wpclient.getPost(postid)
    post.status = status
    #print 'status:', post.status
    ed = wpclient.editPost(postid, post)

def edit_post_status_blogger(user, password, blogid, posturl, status):
    import gdata, atom
    try:
        bgclient = blogger.create_blogger_client(user, password)
    except:
        print 'problems creating bgclient'
        return
        
    control = atom.Control()
    feed = bgclient.GetFeed('/feeds/'+str(blogid)+'/posts/default')
    for entry in feed.entry:
        if entry.GetEditLink().href == posturl:
            #print entry.control
            if status == 'draft':
                control.draft = atom.Draft(text='yes')
                entry.control = control
            else:
                control.draft = None
                entry.control = control
                
            bgclient.Put(entry, posturl)

